package me.hammerle.snuviengine.game;

import me.hammerle.snuviengine.api.ColorRenderer;
import me.hammerle.snuviengine.api.Engine;
import me.hammerle.snuviengine.api.FontRenderer;
import me.hammerle.snuviengine.api.KeyBinding;
import me.hammerle.snuviengine.api.KeyHandler;
import me.hammerle.snuviengine.api.Shader;
import me.hammerle.snuviengine.api.Texture;
import me.hammerle.snuviengine.api.TextureRenderer;
import me.hammerle.snuviengine.util.Clock;
import static org.lwjgl.glfw.GLFW.*;

public class Game extends Engine
{
    private final static KeyBinding UP = KeyHandler.register(GLFW_KEY_W);
    private final static KeyBinding DOWN = KeyHandler.register(GLFW_KEY_S);
    private final static KeyBinding LEFT = KeyHandler.register(GLFW_KEY_A);
    private final static KeyBinding RIGHT = KeyHandler.register(GLFW_KEY_D);
    
    private final ColorRenderer cr = new ColorRenderer();
    private final TextureRenderer tr = new TextureRenderer();
    private final Texture t = new Texture("images/out3.png");
    
    private final FontRenderer fr = new FontRenderer();
    private final Texture text = new Texture("font.png");
    
    float x = 0.0f;
    float y = 0.0f;
    
    int counter = 0;
    
    public Game()
    {
        t.addAnimation(0, 0, "images/water1.png", "images/water2.png", "images/water3.png", "images/water2.png");
    }
    
    @Override
    public void init()
    {
        /*Shader.getMap().getTextureAtlas().addTexture("images/out1.png");
        Shader.getMap().getTextureAtlas().addTexture("images/out2.png");
        Shader.getMap().getTextureAtlas().addTexture("images/out3.png");
        Shader.getMap().getTextureAtlas().addTexture("images/out4.png");
        Shader.getMap().getTextureAtlas().addTexture("images/out5.png");
        
        Shader.getMap().load("test");
        
        Shader.getMap().getAmbientLight().setColor(1.0f, 1.0f, 1.0f);*/
        
        /*Light l = Shader.getMap().getLight(0);
        l.setColor(0.7f, 0.5f, 0.5f);
        l.setStrength(0.005f);
        l.setLocation(100.0f, 100.0f);*/
        
        //Shader.setLightUsing(true);
        Shader.setAmbientLight(0.5f, 0.5f, 0.5f);
        Shader.setLightLocation(0, 100, 100);
        Shader.setLightColor(0, 0.5f, 0.4f, 0.4f);
        Shader.setLightStrength(0, 0.01f);
    }

    @Override
    public void tick()
    {        
        /*if(UP.isDown())
        {
            y += 5;
        }
        if(DOWN.isDown())
        {
            y -= 5;
        }
        if(LEFT.isDown())
        {
            x -= 5;
        }
        if(RIGHT.isDown())
        {
            x += 5;
        }
        Shader.getMap().setCamera(x, y);
        Shader.getMap().getLight(0).setLocation(x + 16, y + 16);*/
        counter++;
        if(counter >= 20)
        {
            counter = 0;
            t.nextFrame();
        }
        
        x += 1f;
    }
    
    private static final Clock clock = new Clock(1000);
    
    @Override
    public void renderTick()
    {
        //Shader.drawMap();
        
        Shader.setTextureUsing(false);

        Shader.translateTo(0, 0);
        Shader.updateMatrix();
        
        cr.setColor(0.15f, 0.15f, 0.15f, 1.0f);
        cr.addRectangle(0, 0, 400, 300);
        cr.build();
        cr.draw();
        
        Shader.setColorUsing(false);
        Shader.setTextureUsing(true);
        t.bindTexture();
        for(int i = 0; i < 192; i += 64)
        {
            tr.addRectangle(i, 64, i + 64, 128, 0.0f, 0.0f, 1.0f, 1.0f);
        }
        tr.build();
        tr.draw();
        
        clock.start();
        text.bindTexture();
        Shader.setColorUsing(true);
        
        Shader.pushMatrix();
        Shader.translateTo(0.0f, 0.0f);
        //Shader.scale(3, 3);
        Shader.updateMatrix();
        
        String s = "Das ist &6ein&f Test. ";
        
        float px = 0.0f;
        float py = 0.0f;
        
        fr.drawString(px, py, true, s);
        px += fr.getSize(s).getWidth();
        py = fr.drawString(px, py, true, s);
        px = 0.0f;
        
        py = fr.drawString(px, py, true, "FPS " + String.format("%.1f", super.getFps()));
        py = fr.drawString(px, py, true, "TPS " + String.format("%.1f", super.getTps()));
        py = fr.drawString(px, py, false, Shader.getViewWidth() + "\n" + Shader.getViewHeight() + "\n" + Shader.getViewScale());
        py = fr.drawString(px, py, false, "Hmm g ji__dfsd\nBlaBlaBlaBla");
        //fr.drawString(0, Shader.getViewHeight() - 60, true, Shader.getViewWidth() + " ");
        //fr.drawString(0, Shader.getViewHeight() - 60, true, Shader.getViewHeight() + " ");
        //fr.drawString(0, Shader.getViewHeight() - 60, true, Shader.getViewScale()+ " ");
        
        Shader.popMatrix();
        Shader.updateMatrix();

        clock.stop();
        clock.printTime("Text:");
    }
}
